%define eclipse_base     %{_libdir}/eclipse
%define gcj_support      1

Distribution:	CCux
Packager:	Christian Metzen <metzench@ccux-linux.de>

Name:      	eclipse-phpeclipse
Version:   	1.2.1
Release:   	1
Summary:   	PHP Eclipse plugin
Group:     	Development/Tools
License:   	CPL
URL:       	http://phpeclipse.net/

# source tarball and the script used to generate it from upstream's source control
# script usage:
# $ sh get-phpeclipse.sh
Source0:   	phpeclipse-%{version}.tar.gz
Source1:   	get-phpeclipse.sh

Patch0:    	%{name}-broken-help-links.patch
Patch1:    	%{name}-fix-build-props.patch
Patch2:    	%{name}-httpd-integration.patch
Patch3:    	%{name}-no-htmlparser.patch
Patch4:   	%{name}-rm-win32-help.patch
Patch5:    	%{name}-external-parser.patch
Patch6:    	%{name}-external-preview.patch

BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if %{gcj_support}
BuildRequires:    gcc-java
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%else
BuildArch:        noarch
%endif
BuildRequires:    java-devel
BuildRequires:    jpackage-utils
BuildRequires:    eclipse-pde >= 3.4
Requires:         java
Requires:         jpackage-utils
Requires:         eclipse-platform >= 3.4
Requires:         php >= 5
Requires:         httpd

%description
PHPEclipse is an open source PHP IDE based on the Eclipse platform. Features
supported include syntax highlighting, content assist, PHP manual integration,
templates and support for the XDebug and DBG debuggers.

%prep
%setup -q -n phpeclipse-%{version}

# apply patches
%patch0 -p4
%patch1 -p4
%patch2 -p4
%patch3 -p4
%patch4 -p4
%patch5 -p4
%patch6 -p4

# ditch bundled libs in favor of building against fedora packaged libs
#rm net.sourceforge.phpeclipse.phpmanual.htmlparser/sax2.jar \
#   net.sourceforge.phpeclipse.phpmanual.htmlparser/htmllexer.jar \
#   net.sourceforge.phpeclipse.phpmanual.htmlparser/filterbuilder.jar \
#   net.sourceforge.phpeclipse.phpmanual.htmlparser/thumbelina.jar \
#   net.sourceforge.phpeclipse.phpmanual.htmlparser/junit.jar \
#   net.sourceforge.phpeclipse.phpmanual.htmlparser/htmlparser.jar
#build-jar-repository -s -p net.sourceforge.phpeclipse.phpmanual.htmlparser xml-commons-apis

#grep -lR sax2 * | xargs sed --in-place "s/sax2/xml-commons-apis/"

# fix jar versions
find -name MANIFEST.MF | xargs sed --in-place "s/0.0.0/%{version}/"

# make sure upstream hasn't sneaked in any jars we don't know about
JARS=""
for j in `find -name "*.jar"`; do
  if [ ! -L $j ]; then
    JARS="$JARS $j"
  fi
done
if [ ! -z "$JARS" ]; then
   echo "These jars should be deleted and symlinked to system jars: $JARS"
   exit 1
fi

%build
# build the main feature
%{eclipse_base}/buildscripts/pdebuild -f net.sourceforge.phpeclipse.feature

# build the debug features
%{eclipse_base}/buildscripts/pdebuild -f net.sourceforge.phpeclipse.debug.feature
%{eclipse_base}/buildscripts/pdebuild -f net.sourceforge.phpeclipse.xdebug.feature

%install
rm -rf %{buildroot}
installDir=%{buildroot}%{_datadir}/eclipse/dropins/phpeclipse
debugInstallDir=%{buildroot}%{_datadir}/eclipse/dropins/phpeclipse-debug
xdebugInstallDir=%{buildroot}%{_datadir}/eclipse/dropins/phpeclipse-xdebug
install -d -m 755 $installDir
install -d -m 755 $debugInstallDir
install -d -m 755 $xdebugInstallDir
unzip -q -d $installDir build/rpmBuild/net.sourceforge.phpeclipse.feature.zip
unzip -q -d $debugInstallDir build/rpmBuild/net.sourceforge.phpeclipse.debug.feature.zip
unzip -q -d $xdebugInstallDir build/rpmBuild/net.sourceforge.phpeclipse.xdebug.feature.zip

# need to recreate the symlinks to libraries that were setup in "prep"
# because for some reason the ant copy task doesn't preserve them
#pushd $installDir/eclipse/plugins/net.sourceforge.phpeclipse.phpmanual.htmlparser_*
#rm *.jar
#build-jar-repository -s -p . xml-commons-apis
#popd

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf %{buildroot}

%if %{gcj_support}
%post -p %{_bindir}/rebuild-gcj-db
%postun -p %{_bindir}/rebuild-gcj-db
%endif

%files
%defattr(-,root,root,-)
%doc net.sourceforge.phpeclipse.feature/cpl-v10.html
%{_datadir}/eclipse/dropins/phpeclipse
%{_datadir}/eclipse/dropins/phpeclipse-debug
%{_datadir}/eclipse/dropins/phpeclipse-xdebug

%if %{gcj_support}
%{_libdir}/gcj/%{name}
%endif

%changelog
* Fri Jan 16 2009 Christian Metzen <metzench@ccux-linux.de> 1.2.1-1
- Version update
* Mon Sep 22 2008 Christian Metzen <metzench@ccux-linux.de> 1.2.0-1
- Initial release
- svn 1573
